#ifndef __ORDER_H__
#define __ORDER_H__

#include "func.h"

typedef struct order_struct {
  int num_funcs;

  /* The following array holds the function pointers in the
     order specified by this data structure. */
  func_t ** func;

  /* This array holds indexes into the above array.  A function's
     index into this array, func_idx, will never change.  It provides
     a level of indirection which allows one number to always refer
     to the same function. */
  unsigned int * func_idx;
} order_t;

#include "seq.h"

order_t * order_load (char * filename);
func_t * order_addr_to_func(order_t * order, unsigned long addr);
order_t * order_copy(order_t * src);
void order_destroy(order_t * order);
void order_print(order_t * order);
void order_destroy_funcs(order_t * order);
void order_span_randomize(order_t * order, int start_func, int end_func);
void order_fix_vmas(order_t * order, unsigned long low_pc);
order_t *  order_filter_seq (order_t * order, seq_t * seq);

#endif /* __ORDER_H__ */
