/* Test the simulated annealing routines by optimizing - x^2 */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <unistd.h>
#include "anneal.h"

double
x2_step (double x)
{
  return x + (((double) rand() / (double) RAND_MAX) - 0.5);
} /* x2_step */

long
x2_eval (double x)
{
  return 10000*x*x;
} /* x2_eval */

int
main(int argc, char ** argv)
{
  long curr_energy, new_energy;
  double temperature;
  double x = 5, new_x;
  int i;

  srand(getpid());

  temperature = 0.5;

  curr_energy = x2_eval(x);
  for (i = 0; i < 100 ; i++)
    {
      new_x = x2_step(x);
      new_energy = x2_eval(new_x);

      if (metrop(curr_energy, new_energy, temperature))
	{
	  x = new_x;
	  curr_energy = new_energy;
	}

      printf("Temp: %g  Energy: %ld System: %g\n", temperature,
	     curr_energy, x);
      
      temperature = temperature * 0.9;
      
    }
  return 0;
}
