#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <string.h>
#include "graph.h"

static node_t *
string2node(graph_t * graph, char * str)
{
  list_t * curr, * nodes;
  node_t * node;

  assert(str != NULL);

  printf("string2node: %s\n", str);

  nodes = graph->nodes;

  curr = nodes;
  while (curr != NULL)
    {
      node = (node_t *) curr->data;
      printf("string2node: Checking %s\n", (char *)node->data);
      if (!strcmp((char *)node->data, str))
	return node;

      curr = curr->next;
    }

  node = node_new(0, strdup(str));

  graph_node_add(graph, node);
  return node;
} /* string2node */

int
main(int argc, char ** argv)
{
  graph_t * graph;
  char line[1024];
  char * n1, * n2;

  graph = graph_new();

  while (!feof(stdin))
    {
      char * p;
      printf("Enter arc: "); fflush(stdout);
      if (fgets(line, sizeof(line), stdin) == NULL)
	return 0;

      p = strchr(line, '\n');
      if (p != NULL) *p = '\0';

      p = strchr(line, ',');
      if (p == NULL)
	{
	  fprintf(stderr,
		  "Syntax error.  Enter arc in this format: foo,bar\n");
	  continue;
	}
      *p = '\0';

      n1 = line;
      n2 = p + 1;

      graph_arc_inc(graph, string2node(graph, n1), string2node(graph, n2), 1);

      graph_print(graph);
    }

  return 0;
} /* main */
